const LinuxUpdater = require('./LinuxUpdater');

describe('linuxUpdater', function () {
  let linuxUpdater,
    updaterOptions = {
      adapter: {
        getAppName: jest.fn(),
        getAppInstallationPath: jest.fn(),
        getAutoUpdater: jest.fn(),
        getLogger: function () {
          return {
            error: jest.fn(),
            info: jest.fn(),
            warn: jest.fn(),
            getContext: jest.fn().mockReturnValue({
              api: '@postman/app-updater',
              domain: 'starship',
            }),
          };
        },
        getOriginalFs: require('fs'),
      },
      autoUpdater: {
        on: jest.fn(),
        downloadUpdate: jest.fn(),
      },
    };

  beforeAll(function () {
    linuxUpdater = new LinuxUpdater(updaterOptions);
  });

  describe('downloadUpdate', function () {
    it('should have updateInfo as an argument', () => {
      let error = null,
        updateInfo = {
          additionalParamsString: 'installationId',
          appId: '7d7c3dea-961e-4b19-b5d7-2106d03a152e',
          arch: '64',
          channel: 'beta',
          downloadURL: 'https://dl.pstmn.io/download/version/6.7.0/osx_64',
          platform: 'OSX',
          updateServerDomain: 'https://dl.pstmn.io/',
          userAgent: 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2)',
          userId: '0',
          version: '6.7.0',
        };

      try {
        linuxUpdater.downloadUpdate(updateInfo);
      } catch (e) {
        error = e;
      } finally {
        expect(error).toBeNull();
      }
    });
  });
});
