const child_process = require('child_process');

const WindowsUpdater = require('./WindowsUpdater');

describe('WindowsUpdater', function () {
  let updaterOptions = {
    autoUpdater: {
      on: jest.fn(),
    },
    adapter: {
      getLogger: function () {
        return {
          error: jest.fn(),
          info: jest.fn(),
          warn: jest.fn(),
          getContext: jest.fn().mockReturnValue({
            api: '@postman/app-updater',
            domain: 'starship',
          }),
        };
      },
      quitApp: jest.fn(),
    },
  };

  describe('run', function () {
    it('should throw error if args is not a Array<string>', () => {
      let args = 123,
        windowsUpdater = new WindowsUpdater(updaterOptions),
        spawnSpy = jest.spyOn(child_process, 'spawn'),
        done = updaterOptions.adapter.quitApp;

      let error = null;
      try {
        windowsUpdater.run(args, done);
      } catch (e) {
        error = e;
      } finally {
        expect(error.name).toEqual('TypeError');
        expect(spawnSpy).toHaveBeenCalledTimes(1);
      }
    });
  });
});
